Subject: Re: [RFC/PATCH] Add the NO_SENTINEL build variable

From: Ramsay Jones <[email-masked]>
Date: Sat, 20 Jul 2013 18:51:28 +0100

Junio C Hamano wrote:
> Ramsay Jones <[email-masked]> writes:
> 
>> Jonathan Nieder wrote:
>>> Ramsay Jones wrote:
>>>
>>>> One of the three gcc compilers that I use does not understand the
>>>> sentinel function attribute. (so, it spews 108 warning messages)
>>>
>>> Do you know what version of gcc introduced the sentinel attribute?
>>> Would it make sense for the ifdef in git-compat-util.h to be keyed on 
>>> __GNUC__ and __GNUC_MINOR__ instead of a new makefile flag?
>>>
>>
>> I have on old (v4.2.1) gcc repo on Linux and looking at
>>
>>     ~/gcc-4.2.1/gcc/ChangeLog-2004
>>
>> I can see that the sentinel attribute was added on 2004-09-04 by
>> Kaveh R. Ghazi.
>>
>> Also, I find "bump version string to version 4.0.0" was on 2004-09-09
>> and "bump version string to version 3.5.0" was on 2004-01-16.
>>
>> Several of my system header files (on Linux) imply that the
>> sentinel attribute is supported by __GNUC__ >= 4. (One of them,
>> ansidecl.h, states that gcc 3.5 supports it but ...)
> 
> Perhaps a message from yesterday would have helped?
> 
>  http://article.gmane.org/gmane.comp.version-control.git/230633
> 
> seems to indicate that checking for version 4 is sufficient.
> 
> Also I asked you to split the __attribute__((sentinel(n)) support
> into a separate patch.  We currently do not pass anything but 0
> (meaning, the sentinel is always at the end), and SENTINEL in all
> capital is easy enough to grep for when somebody _does_ want to have
> such a support, so I'd prefer not to see __attribute__((sentinel(n))
> until it becomes necessary.

Sorry, but I didn't see any of these emails before sending this
and the subsequent patch email. :(

I can sometimes be away from email for several days at a time (and
then spend days trying to read the backlog - I'm on *far* too many
mailing lists!).

[The internet went black on me last night; I couldn't see anything
outside of my ISP's servers (and not all of those). I also couldn't
get any answer at the support phone number, so I probably wasn't the
only one ...]

ATB,
Ramsay Jones